diff -Naur gtk-qt-engine/ChangeLog gtk-qt-engine-read-only/ChangeLog
--- gtk-qt-engine/ChangeLog	2008-03-11 02:30:19.000000000 +0100
+++ gtk-qt-engine-read-only/ChangeLog	2010-02-12 00:26:13.000000000 +0100
@@ -1,9 +1,24 @@
-Changes since 0.8
+Changes since 1.1
 
 Improvements:
- * Ported to Qt4
+ * Set the environment variable GTK_QT_ENGINE_ACTIVE.  Style developers can
+ check for the presence of this variable to change their behaviour depending
+ on whether the their theme is being used by GTK.
+ * Use KDE4's tooltip colors properly
+ * Patch from Thomas Lübking - improve colors in Bespin
+
+Bug fixes:
+ * Fix a divide by 0 exception in styles where there are no scrollbar buttons
+ (cloudcity)
+ * Fix a crash in Firefox's open file dialog
 
 i18n:
- * Updated .pot
- * Included Czech translation by David Watzke
- * Included Italian translation by Davide Madrisan
+ * Korean translation by Park Shinjo
+ * Chinese Simplified translation by nihui
+ * Brazilian portuguese translation by Gustavo Serra Scalet
+ * Updated German translation from Jannick Kuhr
+ * Romanian translation by Sergiu Bivol
+ * Lithuanian translation by Donatas Glodenis
+ * Dutch translation by Verstraete Kenny
+ * Ukrainian translation by Yuri Chornoivan
+ * Updated Norwegian Nynorsk translation by Karl Ove Hufthammer
diff -Naur gtk-qt-engine/po/CMakeLists.txt gtk-qt-engine-read-only/po/CMakeLists.txt
--- gtk-qt-engine/po/CMakeLists.txt	2008-03-11 02:30:19.000000000 +0100
+++ gtk-qt-engine-read-only/po/CMakeLists.txt	2010-02-12 00:26:13.000000000 +0100
@@ -29,7 +29,7 @@
 
 # Stuff to generate the .pot
 FILE(GLOB POT_UIFILES ../kcm_gtk/*.ui)
-SET(POT_SOURCES ../kcm_gtk/kcmgtk.cpp)
+SET(POT_SOURCES ../kcm_gtk/kcmgtk.cpp ../kcm_gtk/firefoxfix.cpp ../kcm_gtk/gtkrcfile.cpp ../kcm_gtk/searchpaths.cpp)
 SET(POT_OUTPUT gtkqtengine.pot)
 
 ADD_CUSTOM_COMMAND(
diff -Naur gtk-qt-engine/src/colormapper.cpp gtk-qt-engine-read-only/src/colormapper.cpp
--- gtk-qt-engine/src/colormapper.cpp	2008-03-11 02:30:19.000000000 +0100
+++ gtk-qt-engine-read-only/src/colormapper.cpp	2010-02-12 00:26:13.000000000 +0100
@@ -25,24 +25,35 @@
 #include <QToolTip>
 
 
-QPalette ColorMapper::mapGtkToQt(GtkStyle* style)
+QPalette ColorMapper::mapGtkToQt(GtkStyle* style, GtkStateType state, bool isButton)
 {
 	QPalette palette(QApplication::palette());
 	
 	mapGtkToQt(style->fg[GTK_STATE_NORMAL],   &palette, QPalette::Active, QPalette::WindowText);
-	mapGtkToQt(style->bg[GTK_STATE_NORMAL],   &palette, QPalette::Active, QPalette::Window);
-	mapGtkToQt(style->text[GTK_STATE_NORMAL], &palette, QPalette::Active, QPalette::Text);
 	mapGtkToQt(style->base[GTK_STATE_NORMAL], &palette, QPalette::Active, QPalette::Base);
 	mapGtkToQt(style->fg[GTK_STATE_SELECTED], &palette, QPalette::Active, QPalette::HighlightedText);
 	mapGtkToQt(style->bg[GTK_STATE_SELECTED], &palette, QPalette::Active, QPalette::Highlight);
 	
 	mapGtkToQt(style->fg[GTK_STATE_INSENSITIVE],   &palette, QPalette::Disabled, QPalette::WindowText);
-	mapGtkToQt(style->bg[GTK_STATE_INSENSITIVE],   &palette, QPalette::Disabled, QPalette::Window);
-	mapGtkToQt(style->text[GTK_STATE_INSENSITIVE], &palette, QPalette::Disabled, QPalette::Text);
 	mapGtkToQt(style->base[GTK_STATE_INSENSITIVE], &palette, QPalette::Disabled, QPalette::Base);
 	mapGtkToQt(style->fg[GTK_STATE_INSENSITIVE],   &palette, QPalette::Disabled, QPalette::HighlightedText);
 	mapGtkToQt(style->bg[GTK_STATE_INSENSITIVE],   &palette, QPalette::Disabled, QPalette::Highlight);
 	
+	if (isButton)
+	{
+		mapGtkToQt(style->bg[state], &palette, QPalette::Active, QPalette::Button);
+		mapGtkToQt(style->fg[state], &palette, QPalette::Active, QPalette::ButtonText);
+		mapGtkToQt(style->bg[GTK_STATE_INSENSITIVE], &palette, QPalette::Disabled, QPalette::Button);
+		mapGtkToQt(style->fg[GTK_STATE_INSENSITIVE], &palette, QPalette::Disabled, QPalette::ButtonText);
+	}
+	else
+	{
+		mapGtkToQt(style->bg[GTK_STATE_NORMAL], &palette, QPalette::Active, QPalette::Window);
+		mapGtkToQt(style->fg[GTK_STATE_NORMAL], &palette, QPalette::Active, QPalette::Text);
+		mapGtkToQt(style->bg[GTK_STATE_INSENSITIVE], &palette, QPalette::Disabled, QPalette::Window);
+		mapGtkToQt(style->fg[GTK_STATE_INSENSITIVE], &palette, QPalette::Disabled, QPalette::Text);
+	}
+	
 	return palette;
 }
 
@@ -52,12 +63,6 @@
 	
 	palette->setColor(group, role, qcolor);
 	
-	// Make button roles the same as normal roles
-	if (role == QPalette::Window)
-		palette->setColor(group, QPalette::Button, qcolor);
-	if (role == QPalette::WindowText)
-		palette->setColor(group, QPalette::ButtonText, qcolor);
-	
 	// The inactive group should be set the same as the active group
 	if (group == QPalette::Active)
 		mapGtkToQt(color, palette, QPalette::Inactive, role);
diff -Naur gtk-qt-engine/src/colormapper.h gtk-qt-engine-read-only/src/colormapper.h
--- gtk-qt-engine/src/colormapper.h	2008-03-11 02:30:19.000000000 +0100
+++ gtk-qt-engine-read-only/src/colormapper.h	2010-02-12 00:26:13.000000000 +0100
@@ -29,7 +29,7 @@
 class ColorMapper
 {
 public:
-	static QPalette mapGtkToQt(GtkStyle* style);
+	static QPalette mapGtkToQt(GtkStyle* style, GtkStateType state, bool isButton);
 
 private:
 	ColorMapper() {}
diff -Naur gtk-qt-engine/src/engine.cpp gtk-qt-engine-read-only/src/engine.cpp
--- gtk-qt-engine/src/engine.cpp	2008-03-11 02:30:19.000000000 +0100
+++ gtk-qt-engine-read-only/src/engine.cpp	2010-02-12 00:26:13.000000000 +0100
@@ -26,8 +26,8 @@
 #include "rcproperties.h"
 
 // Creates an offscreen pixmap of the right size and opens a QPainter on it.
-#define GTK_QT_SETUP(OptionClassName) \
-	QPalette palette(ColorMapper::mapGtkToQt(m_style)); \
+#define GTK_QT_SETUP(OptionClassName, isButton) \
+	QPalette palette(ColorMapper::mapGtkToQt(m_style, m_state, isButton)); \
 	QPixmap offscreenPixmap; \
 	if (m_fillPixmap) \
 		offscreenPixmap = QPixmap(*m_fillPixmap); \
@@ -126,6 +126,9 @@
 	if (!m_enabled)
 		return;
 	
+	// Styles can check for this if they need to enable workarounds for gtk-qt
+	setenv("GTK_QT_ENGINE_ACTIVE", "1", true);
+	
 	// Create a QApplication if there isn't one already
 	if (QApplication::instance() == NULL)
 	{
@@ -236,7 +239,7 @@
 void Engine::drawButton(bool defaultButton)
 {
 	GTK_QT_DEBUG_FUNC
-	GTK_QT_SETUP(QStyleOptionButton)
+	GTK_QT_SETUP(QStyleOptionButton, true)
 	
 	// Handle default buttons (ones that get activated when you press enter)
 	option.features = defaultButton ? QStyleOptionButton::DefaultButton : QStyleOptionButton::None;
@@ -249,7 +252,7 @@
 void Engine::drawCheckBox(bool checked)
 {
 	GTK_QT_DEBUG_FUNC
-	GTK_QT_SETUP(QStyleOptionButton)
+	GTK_QT_SETUP(QStyleOptionButton, true)
 	
 	// Handle checked state
 	m_dummyCheckBox->setChecked(checked);
@@ -267,7 +270,7 @@
 void Engine::drawRadioButton(bool checked)
 {
 	GTK_QT_DEBUG_FUNC
-	GTK_QT_SETUP(QStyleOptionButton)
+	GTK_QT_SETUP(QStyleOptionButton, true)
 	
 	// Handle checked state
 	m_dummyRadioButton->setChecked(checked);
@@ -285,7 +288,7 @@
 void Engine::drawTab(int tabCount, int selectedTab, int tab, bool upsideDown)
 {
 	GTK_QT_DEBUG_FUNC
-	GTK_QT_SETUP(QStyleOptionTabV2)
+	GTK_QT_SETUP(QStyleOptionTabV2, false)
 	option.cornerWidgets = QStyleOptionTab::NoCornerWidgets;
 	option.shape = QTabBar::RoundedNorth;
 	
@@ -333,7 +336,7 @@
 void Engine::drawTabFrame()
 {
 	GTK_QT_DEBUG_FUNC
-	GTK_QT_SETUP(QStyleOptionTabWidgetFrame)
+	GTK_QT_SETUP(QStyleOptionTabWidgetFrame, false)
 	option.shape = QTabBar::RoundedNorth;
 	option.leftCornerWidgetSize = QSize(0, 0);
 	option.rightCornerWidgetSize = QSize(0, 0);
@@ -347,7 +350,7 @@
 void Engine::drawLineEdit(bool editable)
 {
 	GTK_QT_DEBUG_FUNC
-	GTK_QT_SETUP(QStyleOptionFrameV2)
+	GTK_QT_SETUP(QStyleOptionFrameV2, false)
 	option.lineWidth = m_qtStyle->pixelMetric(QStyle::PM_DefaultFrameWidth, &option, m_dummyLineEdit);
 	option.midLineWidth = 0;
 	option.state |= QStyle::State_Sunken;
@@ -363,7 +366,7 @@
 void Engine::drawFrame(int type)
 {
 	GTK_QT_DEBUG_FUNC
-	GTK_QT_SETUP(QStyleOptionFrameV2)
+	GTK_QT_SETUP(QStyleOptionFrameV2, false)
 	option.state |= QStyle::State_Sunken;
 	option.state &= ~QStyle::State_Raised;
 	
@@ -375,7 +378,7 @@
 		default: element = QStyle::PE_Frame;         break;
 	}
 	
-	m_qtStyle->drawPrimitive(element, &option, &p);
+	m_qtStyle->drawPrimitive(element, &option, &p, m_dummyWidget);
 	
 	GTK_QT_FINISH
 }
@@ -383,7 +386,7 @@
 void Engine::drawArrow(GtkArrowType direction)
 {
 	GTK_QT_DEBUG_FUNC
-	GTK_QT_SETUP(QStyleOption)
+	GTK_QT_SETUP(QStyleOption, false)
 	
 	QStyle::PrimitiveElement element;
 	switch (direction)
@@ -403,7 +406,7 @@
 void Engine::drawListHeader()
 {
 	GTK_QT_DEBUG_FUNC
-	GTK_QT_SETUP(QStyleOptionHeader)
+	GTK_QT_SETUP(QStyleOptionHeader, false)
 	option.orientation = Qt::Horizontal;
 	option.section = 1;
 	option.position = QStyleOptionHeader::Middle;
@@ -420,7 +423,7 @@
 void Engine::drawMenuBarItem()
 {
 	GTK_QT_DEBUG_FUNC
-	GTK_QT_SETUP(QStyleOptionMenuItem)
+	GTK_QT_SETUP(QStyleOptionMenuItem, false)
 	option.state |= QStyle::State_Sunken | QStyle::State_Selected;
 	option.state &= ~QStyle::State_Raised;
 	
@@ -432,7 +435,7 @@
 void Engine::drawMenu()
 {
 	GTK_QT_DEBUG_FUNC
-	GTK_QT_SETUP(QStyleOptionFrame)
+	GTK_QT_SETUP(QStyleOptionFrame, false)
 	option.state = QStyle::State_None;
 	option.lineWidth = style()->pixelMetric(QStyle::PM_MenuPanelWidth);
 	option.midLineWidth = 0;
@@ -445,7 +448,7 @@
 void Engine::drawMenuItem(int type)
 {
 	GTK_QT_DEBUG_FUNC
-	GTK_QT_SETUP(QStyleOptionMenuItem)
+	GTK_QT_SETUP(QStyleOptionMenuItem, false)
 	option.state |= QStyle::State_Sunken | QStyle::State_Selected;
 	option.state &= ~QStyle::State_Raised;
 	
@@ -464,7 +467,7 @@
 void Engine::drawMenuCheck()
 {
 	GTK_QT_DEBUG_FUNC
-	GTK_QT_SETUP(QStyleOption)
+	GTK_QT_SETUP(QStyleOption, false)
 	
 	m_qtStyle->drawPrimitive(QStyle::PE_IndicatorMenuCheckMark, &option, &p, m_dummyMenu);
 	
@@ -474,7 +477,7 @@
 void Engine::drawHLine()
 {
 	GTK_QT_DEBUG_FUNC
-	GTK_QT_SETUP(QStyleOption)
+	GTK_QT_SETUP(QStyleOption, false)
 	
 	qDrawShadeLine(&p, 0, 0, m_size.width(), 0, option.palette);
 	
@@ -484,7 +487,7 @@
 void Engine::drawVLine()
 {
 	GTK_QT_DEBUG_FUNC
-	GTK_QT_SETUP(QStyleOption)
+	GTK_QT_SETUP(QStyleOption, false)
 	
 	qDrawShadeLine(&p, 0, 0, 0, m_size.height(), option.palette);
 	
@@ -494,7 +497,7 @@
 void Engine::drawComboBox()
 {
 	GTK_QT_DEBUG_FUNC
-	GTK_QT_SETUP(QStyleOptionComboBox)
+	GTK_QT_SETUP(QStyleOptionComboBox, true)
 	
 	m_qtStyle->drawComplexControl(QStyle::CC_ComboBox, &option, &p, m_dummyComboBox);
 	
@@ -504,7 +507,7 @@
 void Engine::drawProgressBar(GtkProgressBarOrientation orientation, double percentage)
 {
 	GTK_QT_DEBUG_FUNC
-	GTK_QT_SETUP(QStyleOptionProgressBarV2)
+	GTK_QT_SETUP(QStyleOptionProgressBarV2, false)
 	option.maximum = 10000;
 	option.minimum = 0;
 	option.progress = int(percentage * 10000);
@@ -529,7 +532,7 @@
 void Engine::drawProgressChunk()
 {
 	GTK_QT_DEBUG_FUNC
-	GTK_QT_SETUP(QStyleOptionProgressBarV2)
+	GTK_QT_SETUP(QStyleOptionProgressBarV2, false)
 	option.maximum = 10000;
 	option.minimum = 0;
 	option.progress = 10000;
@@ -542,7 +545,7 @@
 void Engine::drawSpinButton(int direction)
 {
 	GTK_QT_DEBUG_FUNC
-	GTK_QT_SETUP(QStyleOptionSpinBox)
+	GTK_QT_SETUP(QStyleOptionSpinBox, false)
 	option.frame = false;
 	
 	QStyle::PrimitiveElement element;
@@ -561,7 +564,7 @@
 void Engine::drawSlider(GtkAdjustment* adj, GtkOrientation orientation, int inverted)
 {
 	GTK_QT_DEBUG_FUNC
-	GTK_QT_SETUP(QStyleOptionSlider)
+	GTK_QT_SETUP(QStyleOptionSlider, false)
 	option.minimum = 0;
 	option.maximum = 10000;
 	option.orientation = (orientation == GTK_ORIENTATION_HORIZONTAL) ? Qt::Horizontal : Qt::Vertical;
@@ -581,7 +584,7 @@
 void Engine::drawScrollBar(GtkOrientation orientation, GtkAdjustment* adj)
 {
 	GTK_QT_DEBUG_FUNC
-	GTK_QT_SETUP(QStyleOptionSlider)
+	GTK_QT_SETUP(QStyleOptionSlider, false)
 	option.minimum = int(adj->lower);
 	option.maximum = int(adj->upper - adj->page_size);
 	option.singleStep = int(adj->step_increment);
@@ -617,7 +620,7 @@
 		m_size = QSize(m_size.width(), m_size.height() + extraSpace);
 
 	GTK_QT_DEBUG_FUNC
-	GTK_QT_SETUP(QStyleOptionSlider)
+	GTK_QT_SETUP(QStyleOptionSlider, false)
 	option.minimum = 0;
 	option.maximum = 1;
 	option.singleStep = 10000;
@@ -638,6 +641,8 @@
 	
 	// Figure out where the slider is.  Hope this rect is the same size as oldSize
 	QRect sliderRect = m_qtStyle->subControlRect(QStyle::CC_ScrollBar, &option, QStyle::SC_ScrollBarSlider, m_dummyScrollBar);
+	if (sliderRect.width() < 0 || sliderRect.height() < 0) // Firefox again :(
+		return;
 	
 	// Get rid of the buttons so we're left with just the scrollbar slider of the size we were asked to draw
 	offscreenPixmap = offscreenPixmap.copy(sliderRect);
@@ -648,7 +653,7 @@
 void Engine::drawSplitter(GtkOrientation orientation)
 {
 	GTK_QT_DEBUG_FUNC
-	GTK_QT_SETUP(QStyleOption)
+	GTK_QT_SETUP(QStyleOption, false)
 	
 	// By "horizontal", GTK means "bar goes from left to right" and Qt means "the two panes are to the left and right of the bar"
 	if (orientation != GTK_ORIENTATION_HORIZONTAL)
diff -Naur gtk-qt-engine/src/engine.h gtk-qt-engine-read-only/src/engine.h
--- gtk-qt-engine/src/engine.h	2008-03-11 02:30:19.000000000 +0100
+++ gtk-qt-engine-read-only/src/engine.h	2010-02-12 00:26:13.000000000 +0100
@@ -39,6 +39,7 @@
 #include <QScrollBar>
 
 #include <gtk/gtk.h>
+#include <gtk/gtkstyle.h>
 #include <gdk/gdkx.h>
 
 // The GTK headers suck
diff -Naur gtk-qt-engine/src/qt_theme_draw.c gtk-qt-engine-read-only/src/qt_theme_draw.c
--- gtk-qt-engine/src/qt_theme_draw.c	2008-03-11 02:30:19.000000000 +0100
+++ gtk-qt-engine-read-only/src/qt_theme_draw.c	2010-02-12 00:26:13.000000000 +0100
@@ -19,6 +19,7 @@
  ***************************************************************************/
 
 #include <math.h>
+#include <stdlib.h>
 #include <string.h>
 #include <gtk/gtkprogressbar.h>
 #include <gdk/gdk.h>
diff -Naur gtk-qt-engine/src/rcproperties.cpp gtk-qt-engine-read-only/src/rcproperties.cpp
--- gtk-qt-engine/src/rcproperties.cpp	2008-03-11 02:30:19.000000000 +0100
+++ gtk-qt-engine-read-only/src/rcproperties.cpp	2010-02-12 00:26:13.000000000 +0100
@@ -18,16 +18,26 @@
  *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
  ***************************************************************************/
 
+#include <QDir> // This has to be above any GTK headers
+
 #include "utilities.h"
 #include "rcproperties.h"
 #include "engine.h"
 
-#include <QDebug>
+#include <QtDebug>
 #include <QToolTip>
 #include <QFile>
 #include <QSettings>
 #include <QFileInfo>
 
+#define INITDUMMY(className) \
+	dummy.setPalette(QApplication::palette()); \
+	dummy.setObjectName(className); \
+	Engine::instance()->m_qtStyle->polish(&dummy);
+
+#define WCOLOR(class, role) \
+	GtkQtUtilities::colorString(dummy.palette().color(QPalette::class, QPalette::role))
+
 
 bool RcProperties::s_scrollBarHasBack1;
 bool RcProperties::s_scrollBarHasForward1;
@@ -44,22 +54,55 @@
 {
 	GTK_QT_DEBUG_FUNC
 	
+	initKdeSettings();
+	
 	setWidgetProperties();
 	setColorProperties();
 	setIconProperties();
+	
+	// KDE's "Apply colors to non-KDE apps" setting is broken.
+	// It applies colors to the "*" class which overrides colors set by the style
+	// We take the (rather extreme) measure of removing its gtkrc file
+	
+	char** rcFiles = gtk_rc_get_default_files();
+	while (*rcFiles != NULL)
+	{
+		QString fileName(*(rcFiles++));
+		
+		if (!fileName.endsWith("/share/config/gtkrc-2.0"))
+			continue;
+		
+		// Open the file and check for a known string just to make
+		// sure we're not accidentally deleting something else
+		QFile file(fileName);
+		if (!file.exists())
+			continue;
+		
+		file.open(QIODevice::ReadOnly);
+		if (!file.readLine(20).startsWith("# created by KDE"))
+			continue;
+		
+		file.close();
+		file.remove();
+	}
 }
 
 void RcProperties::setWidgetProperties()
 {
 	const QStyle* qtStyle = Engine::instance()->m_qtStyle;
 	
+	// Buttons
+	GtkQtUtilities::parseRcString("GtkButton::child_displacement_x = " + QString::number(qtStyle->pixelMetric(QStyle::PM_ButtonShiftHorizontal)), "*", GtkQtUtilities::WidgetClass);
+	GtkQtUtilities::parseRcString("GtkButton::child_displacement_y = " + QString::number(qtStyle->pixelMetric(QStyle::PM_ButtonShiftVertical)), "*", GtkQtUtilities::WidgetClass);
+	
 	// Check boxes
 	// We add 2 to the size to account for the box around the check indicator
 	GtkQtUtilities::parseRcString("GtkCheckButton::indicator-size = " + QString::number(qtStyle->pixelMetric(QStyle::PM_IndicatorHeight) + 2), "*", GtkQtUtilities::WidgetClass);
 	
 	// Tabs
+	GtkQtUtilities::parseRcString("GtkButton::tab-curvature = 0", "*", GtkQtUtilities::WidgetClass);
 	GtkQtUtilities::parseRcString("GtkNotebook::tab-overlap = " + QString::number(qtStyle->pixelMetric(QStyle::PM_TabBarTabOverlap)), "*", GtkQtUtilities::WidgetClass);
-	GtkQtUtilities::parseRcString("xthickness = 3", "*.GtkNotebook", GtkQtUtilities::WidgetClass); // Hardcode values that look good
+	GtkQtUtilities::parseRcString("xthickness = 2", "*.GtkNotebook", GtkQtUtilities::WidgetClass); // Hardcode values that look good
 	GtkQtUtilities::parseRcString("ythickness = 3", "*.GtkNotebook", GtkQtUtilities::WidgetClass);
 	
 	// Line edits
@@ -131,7 +174,16 @@
 	
 	int availableSize = 200 - qtStyle->subControlRect(QStyle::CC_ScrollBar, &option, QStyle::SC_ScrollBarGroove, scrollBar).width();
 	s_scrollBarButtonCount = s_scrollBarHasForward1 + s_scrollBarHasBack1 + s_scrollBarHasForward2 + s_scrollBarHasBack2; // Evil
-	s_scrollBarButtonSize = availableSize / s_scrollBarButtonCount;
+	if (s_scrollBarButtonCount != 0)
+		s_scrollBarButtonSize = availableSize / s_scrollBarButtonCount;
+}
+
+QString RcProperties::gtkPaletteString(const QPalette& pal, const QString& bgfg, QPalette::ColorRole role)
+{
+	return bgfg + "[NORMAL] = "      + GtkQtUtilities::colorString(pal.color(QPalette::Inactive, role)) + "\n"
+	     + bgfg + "[ACTIVE] = "      + GtkQtUtilities::colorString(pal.color(QPalette::Active, role))   + "\n"
+	     + bgfg + "[PRELIGHT] = "    + GtkQtUtilities::colorString(pal.color(QPalette::Active, role))   + "\n"
+	     + bgfg + "[INSENSITIVE] = " + GtkQtUtilities::colorString(pal.color(QPalette::Disabled, role)) + "\n";
 }
 
 void RcProperties::setColorProperties()
@@ -167,24 +219,72 @@
 	mapColor("base[INSENSITIVE]", QPalette::Disabled, QPalette::Base);
 	
 	// Tooltips
-	QString tooltipColor = GtkQtUtilities::colorString(QToolTip::palette().color(QPalette::Active, QPalette::Base));
-	GtkQtUtilities::parseRcString("bg[NORMAL] = " + tooltipColor, "*.tooltips.*.GtkToggleButton", GtkQtUtilities::WidgetClass);
-	GtkQtUtilities::parseRcString("bg[NORMAL] = " + tooltipColor, "gtk-tooltips", GtkQtUtilities::Widget);
-	GtkQtUtilities::parseRcString("bg[NORMAL] = " + tooltipColor, "gtk-tooltip", GtkQtUtilities::Widget);
-	
-	// Buttons
-	QString buttonColor = GtkQtUtilities::colorString(QApplication::palette().color(QPalette::Active, QPalette::Button));
-	GtkQtUtilities::parseRcString("bg[NORMAL] = " + buttonColor, "GtkButton", GtkQtUtilities::Class);
-	GtkQtUtilities::parseRcString("bg[ACTIVE] = " + buttonColor, "GtkButton", GtkQtUtilities::Class);
-	GtkQtUtilities::parseRcString("bg[NORMAL] = " + buttonColor, "GtkOptionMenu", GtkQtUtilities::Class);
-	GtkQtUtilities::parseRcString("bg[ACTIVE] = " + buttonColor, "GtkOptionMenu", GtkQtUtilities::Class);
-	
-	buttonColor = GtkQtUtilities::colorString(QApplication::palette().color(QPalette::Disabled, QPalette::Button));
-	GtkQtUtilities::parseRcString("bg[INSENSITIVE] = " + buttonColor, "GtkButton", GtkQtUtilities::Class);
+	QColor tooltipBg(convertColor(kdeConfigValue("/share/config/kdeglobals", "Colors:Tooltip/BackgroundNormal", QToolTip::palette().color(QPalette::Active, QPalette::Base), true).second));
+	QColor tooltipFg(convertColor(kdeConfigValue("/share/config/kdeglobals", "Colors:Tooltip/ForegroundNormal", QToolTip::palette().color(QPalette::Active, QPalette::Text), true).second));
+	GtkQtUtilities::parseRcString("bg[NORMAL] = " + GtkQtUtilities::colorString(tooltipBg), "gtk-tooltip*", GtkQtUtilities::Widget);
+	GtkQtUtilities::parseRcString("fg[NORMAL] = " + GtkQtUtilities::colorString(tooltipFg), "gtk-tooltip*", GtkQtUtilities::Widget);
 	
 	// Lists
 	QString activeListColor = GtkQtUtilities::colorString(QApplication::palette().color(QPalette::Active, QPalette::HighlightedText));
 	GtkQtUtilities::parseRcString("text[ACTIVE] = " + activeListColor, "GtkTreeView", GtkQtUtilities::Class);
+	
+	// Patch from Thomas Lübking:
+	// Ask the Qt style for color settings of a (growing?) bunch of widget types.
+	// We pass a dummy widget to QStyle::polish(QWidget*) with the widget's object
+	// name reflecting (a faked) QObject::className alongside with the apps
+	// default palette - if the style changes the palette, we add a gtk style
+	// for the matching gtk widgets
+	// NOTICE using a dummy widget objectName rather than a matching QWidget
+	// here does not only allow us to skip couple of widget headers here for no
+	// sense, but also is REQUIRED! because the Qt styles tend to do freaky things
+	// on certain widget types, which we need to prevent...
+	//
+	// as the GTK and Qt palette models do not really fit, we'll translate
+	// QPalette::Inactive -> GTK_STATE_NORMAL
+	// QPalette::Active -> GTK_STATE_PRELIGHT
+	// QPalette::Active -> GTK_STATE_ACTIVE
+	// QPalette::Disabled -> GTK_STATE_INSENSITIVE
+	
+	QWidget dummy;
+	
+	INITDUMMY("QPushButton")
+	GtkQtUtilities::parseRcString(gtkPaletteString(dummy.palette(), "bg", QPalette::Button), "GtkButton", GtkQtUtilities::Class);
+	GtkQtUtilities::parseRcString(gtkPaletteString(dummy.palette(), "fg", QPalette::ButtonText), "*.GtkButton*GtkLabel", GtkQtUtilities::WidgetClass);
+	
+	INITDUMMY("QComboBox")
+	GtkQtUtilities::parseRcString(gtkPaletteString(dummy.palette(), "bg", QPalette::Button), "GtkOptionMenu", GtkQtUtilities::Class);
+
+	INITDUMMY("QCheckBox")
+	GtkQtUtilities::parseRcString(gtkPaletteString(dummy.palette(), "bg", QPalette::Button), "GtkCheckButton", GtkQtUtilities::Class);
+	
+	INITDUMMY("QRadioButton")
+	GtkQtUtilities::parseRcString(gtkPaletteString(dummy.palette(), "bg", QPalette::Button), "GtkRadioButton", GtkQtUtilities::Class);
+	
+	INITDUMMY("QTabBar")
+	if (dummy.palette() != QApplication::palette())
+	{
+		// SIC! GTK thinks all tabs but the active are active...
+		GtkQtUtilities::parseRcString(
+			"fg[ACTIVE] = "      + WCOLOR(Inactive, WindowText) + "\n" +
+			"fg[NORMAL] = "      + WCOLOR(Active, WindowText) + "\n" +
+			"fg[PRELIGHT] = "    + WCOLOR(Active, WindowText) + "\n" +
+			"fg[INSENSITIVE] = " + WCOLOR(Disabled, WindowText),
+			"*.GtkNotebook.GtkLabel", GtkQtUtilities::WidgetClass);
+	}
+
+	INITDUMMY("QMenu")
+	if (dummy.palette() != QApplication::palette())
+	{
+		GtkQtUtilities::parseRcString(gtkPaletteString(dummy.palette(), "bg", QPalette::Window), "GtkMenu", GtkQtUtilities::Class);
+		GtkQtUtilities::parseRcString(gtkPaletteString(dummy.palette(), "fg", QPalette::WindowText), "*.GtkMenuItem.GtkLabel", GtkQtUtilities::Class);
+	}
+
+	INITDUMMY("QMenuBar")
+	if (dummy.palette() != QApplication::palette())
+	{
+		GtkQtUtilities::parseRcString(gtkPaletteString(dummy.palette(), "bg", QPalette::Window), "GtkMenuBar", GtkQtUtilities::Class);
+		GtkQtUtilities::parseRcString(gtkPaletteString(dummy.palette(), "fg", QPalette::WindowText), "*.GtkMenuBar.GtkMenuItem.GtkLabel", GtkQtUtilities::WidgetClass);
+	}
 }
 
 void RcProperties::mapColor(const QString& name, QPalette::ColorGroup group, QPalette::ColorRole role)
@@ -192,7 +292,7 @@
 	QPalette palette(QApplication::palette());
 	QString color(GtkQtUtilities::colorString(palette.color(group, role)));
 	
-	GtkQtUtilities::parseRcString(name + " = " + color, "*", GtkQtUtilities::Class);
+	GtkQtUtilities::parseRcString(name + " = " + color, "GtkWidget", GtkQtUtilities::Class);
 }
 
 PathAndValue RcProperties::kdeConfigValue(const QString& file, const QString& key, const QVariant& def, bool searchAllFiles)
@@ -239,15 +339,14 @@
 		s_kdeSearchPaths << kdeDir;
 	s_kdeSearchPaths << settings.value("KDEPrefix").toString();
 	
+	s_kdeSearchPaths << QDir::homePath() + "/.kde4";
+	s_kdeSearchPaths << QDir::homePath() + "/.kde";
 	s_kdeSearchPaths << "/usr/local";
 	s_kdeSearchPaths << "/usr";
 }
 
 void RcProperties::setIconProperties()
 {
-	// Find the current KDE icon theme
-	initKdeSettings();
-	
 	// Get the theme's directory and those of its parents
 	QString iconThemeName(kdeConfigValue("/share/config/kdeglobals", "Icons/Theme", "oxygen", true).second.toString());
 	traverseIconThemeDir(iconThemeName);
@@ -352,7 +451,7 @@
 	iconMappings += doIconMapping("gtk-zoom-fit", "actions/zoom-fit-best.png");
 	iconMappings += doIconMapping("gtk-zoom-in", "actions/zoom-in.png");
 	iconMappings += doIconMapping("gtk-zoom-out", "actions/zoom-out.png");
-	iconMappings += "} class \"*\" style \"KDE-icons\"";
+	iconMappings += "} class \"GtkWidget\" style \"KDE-icons\"";
 	
 	GtkQtUtilities::parseRcString(iconMappings);
 }
@@ -422,3 +521,19 @@
 	
 	return "stock[\"" + stockName + "\"] = {" + lines.join(",") + "}\n";
 }
+
+QColor RcProperties::convertColor(const QVariant& variant)
+{
+	if (variant.value<QColor>().isValid())
+		return variant.value<QColor>();
+	
+	// KDE seems to store colors in its config files as QStringList(r, g, b), which you can't convert
+	// with QVariant::value<QColor>
+	QStringList list(variant.toStringList());
+	if (list.count() == 3)
+		return QColor(list[0].toInt(), list[1].toInt(), list[2].toInt());
+	else if (list.count() == 4)
+		return QColor(list[0].toInt(), list[1].toInt(), list[2].toInt(), list[3].toInt());
+	return QColor();
+}
+
diff -Naur gtk-qt-engine/src/rcproperties.h gtk-qt-engine-read-only/src/rcproperties.h
--- gtk-qt-engine/src/rcproperties.h	2008-03-11 02:30:19.000000000 +0100
+++ gtk-qt-engine-read-only/src/rcproperties.h	2010-02-12 00:26:13.000000000 +0100
@@ -51,6 +51,8 @@
 	static QString doIconMapping(const QString& stockName, const QString& path);
 	
 	static void mapColor(const QString& name, QPalette::ColorGroup group, QPalette::ColorRole role);
+	static QColor convertColor(const QVariant& variant);
+	static QString gtkPaletteString(const QPalette& pal, const QString& bgfg, QPalette::ColorRole role = QPalette::Window);
 	
 	static bool s_scrollBarHasBack1;
 	static bool s_scrollBarHasForward1;
